/* =============================================================
   Test 5:  bi-directional using persistent requests
   Scheme
   only once:
   Send_init
   Recv_init
   in loop:		
   Startall
   WaitAll
   ================================================================ */



#include "transfer.h"


static MPI_Status Statuses[2];
static MPI_Request Requests[2]; 
extern int headproc;

const char test_description[] = "Bi-directional/Persistent requests (6)";

void transfer_test_operation(void *sendbuf,void *recvbuf,int msglen,int rank,int TIMES,int proc){
  int the_other;
  int i;	

  if(proc == headproc)
    return;		

  if(rank == headproc || rank == proc){
    the_other = (rank == headproc) ? proc : headproc;
	
    MPI_Send_init(sendbuf,msglen,MPI_CHAR,the_other,TAG1,comm,&Requests[0]);
    MPI_Recv_init(recvbuf,msglen,MPI_CHAR,the_other,TAG1,comm,&Requests[1]);
	
    for(i = 0; i < TIMES; i ++){
      MPI_Startall(2,Requests);
      MPI_Waitall(2,Requests,Statuses);
    }
  }
}
